#include <iostream>
typedef struct {
int mini;
int maxi;
}Vaga;
typedef struct {
int prvi;
int drugi;
int kilaza;
}Pitanja;
using namespace std;

int main()
{
    int brVaga,brPitanja,odgovori[10000];
    Vaga v[100005];
    Pitanja p[100005];
    cin >> brVaga >> brPitanja;
    for(int i = 0; i < brVaga; i++){
    cin >> v[i].mini >> v[i].maxi;
    }
    for(int i = 0; i < brPitanja; i++){
    cin >> p[i].prvi >> p[i].drugi>>p[i].kilaza;
    }
    for(int i = 0; i < brPitanja; i++){
    if(!(v[p[i].prvi].mini > p[i].kilaza)){
        if(!(v[p[i].prvi].maxi < p[i].kilaza))
        {
           odgovori[i] = 1;
        }
    }else odgovori[i] = 0;
    }
    for(int i = 0; i < brPitanja; i++){
    cout << odgovori[i] << endl;
    }
    return 0;
}